
VERSION "1.00"
CONSOLE

IMPORT "xst"

DECLARE FUNCTION Entry ()
DECLARE FUNCTION wildcmp (mask$, search$)

FUNCTION Entry ()

  DIM mask$[12]
  mask$[0] = "test.x"
  mask$[1] = "test*.x"
  mask$[2] = "*test.x"
  mask$[3] = "te*.x"
  mask$[4] = "*st.x"
  mask$[5] = "t*t.x"
  mask$[6] = "t*st.x"
  mask$[7] = "*.x"
  mask$[8] = "*.*"
  mask$[9] = "te?t.x"
  mask$[10] = "????.x"
  mask$[11] = "????.?"
  mask$[12] = "" ' empty
  search$ = "test.x"
  PRINT "*** Matches on "; search$; " ***\n"

  FOR i = 0 TO UBOUND (mask$[])
    bMatch = wildcmp(mask$[i], search$)
    PRINT mask$[i];
    IFZ mask$[i] THEN PRINT " (empty mask)";
    IF bMatch THEN
      PRINT " matches (good!)"
    ELSE
      PRINT " does not match (bad!)"
    END IF
  NEXT i

  DIM mask$[13]
  mask$[0] = "tast.x"
  mask$[1] = "*x.x"
  mask$[2] = "?e?t?.x"
  mask$[3] = "t?t?.x"
  mask$[4] = "?????.x"
  mask$[5] = "???.x"
  mask$[6] = "test?.x"
  mask$[7] = "?test.x"
  mask$[8] = "te?.x"
  mask$[9] = "?st.x"
  mask$[10] = "t?t.x"
  mask$[11] = "t?est.x"
  mask$[12] = "?.x"
  mask$[13] = "?.?"
  search$ = "test.x"
  PRINT "\n\n*** Does not match on "; search$; " ***\n"
  FOR i = 0 TO UBOUND (mask$[])
    bMatch = wildcmp(mask$[i], search$)
    PRINT mask$[i];
    IF bMatch THEN
      PRINT " matches (bad!)"
    ELSE
      PRINT " does not match (good!)"
    END IF
  NEXT i

  DIM mask$[13]
  mask$[0] = "a.rtf"
  mask$[1] = "a*.rtf"
  mask$[2] = "*a.rtf"
  mask$[3] = "*.rtf"
  mask$[4] = "*.*"
  mask$[5] = "?.rtf"
  mask$[6] = "?.?tf"
  mask$[7] = "?.r?f"
  mask$[8] = "?.rt?"
  mask$[9] = "?.??f"
  mask$[10] = "?.r??"
  mask$[11] = "?.?t?"
  mask$[12] = "?.???"
  mask$[13] = "" ' empty
  search$ = "a.rtf"
  PRINT "\n\n*** Matches on "; search$; " ***\n"

  FOR i = 0 TO UBOUND (mask$[])
    bMatch = wildcmp(mask$[i], search$)
    PRINT mask$[i];
    IFZ mask$[i] THEN PRINT " (empty mask)";
    IF bMatch THEN
      PRINT " matches (good!)"
    ELSE
      PRINT " does not match (bad!)"
    END IF
  NEXT i

  DIM mask$[10]
  mask$[0] = "aa.rtf"
  mask$[1] = "*x.rtf"
  mask$[2] = "?a?.rtf"
  mask$[3] = "a??.rtf"
  mask$[4] = "??.rtf"
  mask$[5] = ".rtf"
  mask$[6] = "a?.rtf"
  mask$[7] = "?a.rtf"
  mask$[8] = "ae?.rtf"
  mask$[9] =  "?.rt"
  mask$[10] = "?.??"
  search$ = "a.rtf"
  PRINT "\n\n*** Does not match on "; search$; " ***\n"
  FOR i = 0 TO UBOUND (mask$[])
    bMatch = wildcmp(mask$[i], search$)
    PRINT mask$[i];
    IF bMatch THEN
      PRINT " matches (bad!)"
    ELSE
      PRINT " does not match (good!)"
    END IF
  NEXT i

  a$ = INLINE$ ("\nPress Enter to quit >")
  QUIT (0)

END FUNCTION

FUNCTION wildcmp (mask$, search$)
	' wildcmp (const char *wild, const char *string)
	' Name: wildcmp -- wildcard string compare (globbing)
	' Description: matches a string against
	'     a wildcard string such as "*.*" or "bl?h
	'     .*" etc. This is good for file globbing
	'     or to match hostmasks.
	' By: Jack Handy, 05/2/2001
	'
	' Returns: $$TRUE on match, $$FALSE on no match.

  ULONG cp, searchPos
  ULONG mp, maskPos

  IFZ search$ THEN RETURN $$FALSE 	' no match
  IFZ mask$ THEN RETURN $$TRUE 			' no filtering => it's a match
	IF mask$ = "*" THEN RETURN $$TRUE ' no filtering => it's a match!

  searchPos = 0
  maskPos = 0
  DO WHILE (search${searchPos}) && (mask${maskPos} <> '*')
    IF (mask${maskPos} <> search${searchPos}) && (mask${maskPos} <> '?') THEN RETURN $$FALSE
    INC maskPos
    INC searchPos
  LOOP

  DO WHILE (search${searchPos})
    SELECT CASE mask${maskPos}
      CASE '*'
        INC maskPos
        IF !(mask${maskPos}) THEN RETURN $$TRUE
        mp = maskPos
        cp = searchPos + 1
      CASE '?', search${searchPos}
        INC maskPos
        INC searchPos
      CASE ELSE
        maskPos = mp
        searchPos = cp
        IF search${searchPos} THEN INC cp
    END SELECT
  LOOP

  DO WHILE (mask${maskPos} == '*')
    INC maskPos
  LOOP

  RETURN !mask${maskPos}

END FUNCTION
END PROGRAM 